<?xml version="1.0" ?>
<launch>
    <!-- idea : launch a simulation instance without gazebo; only via Rviz. Check if it works-->

    <arg name="sim" default="false" />
    <arg name="model" default="gimbal" />
    <arg name="controller" value="velocity_control"/>
    <arg name="using_rosbag" default="false"/>
    <arg name="using_gazebo" default="false"/>

  <arg name="x"           default="0.0"     doc="How far forward to place the base of the robot in [m]?" />
  <arg name="y"           default="0.0"     doc="How far leftwards to place the base of the robot in [m]?" />
  <arg name="z"           default="0.0"     doc="How far upwards to place the base of the robot in [m]?" />
  <arg name="roll"        default="-1.57078"     doc="How much to rotate the base of the robot around its X-axis in [rad]?" />
  <arg name="pitch"       default="0.0"     doc="How much to rotate the base of the robot around its Y-axis in [rad]?" />
  <arg name="yaw"         default="0.0"     doc="How much to rotate the base of the robot around its Z-axis in [rad]?" />

    <env name="ROSCONSOLE_CONFIG_FILE" value="$(find gimbal_gazebo_qontrol)/config/rosconsol.conf"/>
    <group ns="$(arg model)">
        <rosparam command="load" file="$(find gimbal_gazebo_qontrol)/config/velocity_control.yaml" />
        

        <param unless="$(arg sim)" name="robot_description"
         command="$(find xacro)/xacro $(find gimbal_description)/robots/gimbal.urdf.xacro
                  model:=gimbal">
        </param>

        <param if="$(arg sim)" name="robot_description"
         command="xacro $(find gimbal_description)/robots/gimbal.urdf.xacro
            connected_to:=world
            xyz:='$(arg x) $(arg y) $(arg z)'
            rpy:='$(arg roll) $(arg pitch) $(arg yaw)'              
            ">
        </param>


        <group unless="$(arg sim)">


            <!-- <include file="$(find gimbal_control)/launch/gimbal_control.launch" >
            </include> -->
            
            <node name="controller_spawner" pkg="controller_manager" type="spawner" respawn="false" output="screen" args="$(arg controller)"/>

            <node name="g_main_node" type="gimbal_main_node" pkg="gimbal_gazebo_qontrol" output="screen">
                <param name="varPath" value="/$(arg model)/$(arg controller)"/>
                <param name="rate" value="100"/>
                <param name="sim" value="false"/>
                <param name="withGazebo" value="false"/>
            </node>
                <node name="robot_state_publisher" pkg="robot_state_publisher" type="robot_state_publisher" respawn="false" output="screen">
            <!-- <remap from="joint_states" to="/gimbal/desired_joint_states" /> -->
                 <remap from="joint_states" to="/joint_states" />
            </node>    
        </group>

        
        <node name="rviz" pkg="rviz"  type="rviz" args="-d $(find gimbal_gazebo_qontrol)/launch/robot.rviz"/>
    </group>



    <group if="$(arg sim)">


        <include if="$(arg using_gazebo)" file="$(find gimbal_gazebo_qontrol)/launch/basic_launch/simulation.launch" >
            <arg name="controller" value="$(arg controller)"/>
            <arg name="using_rosbag" value="$(arg using_rosbag)"/>
        </include>

        <node name="g_main_node" type="gimbal_main_node" pkg="gimbal_gazebo_qontrol" output="screen">
            <param name="withGazebo" value="$(arg using_gazebo)"/>
            <param name="varPath" value="/$(arg model)/$(arg controller)"/>
            <param name="rate" value="100"/>
            <param name="sim" value="true"/>
            <param name="withGazebo" value="$(arg using_gazebo)"/>
        </node>

        <include unless="$(arg using_gazebo)" file="$(find gimbal_gazebo_qontrol)/launch/basic_launch/simple_simulation.launch" >
            <arg name="controller" value="$(arg controller)"/>
            <arg name="using_rosbag" value="$(arg using_rosbag)"/>
        </include>

    </group>
  
</launch>
